;; Problem 12
;; 08 March 2002

;; The sequence of triangle numbers is generated by adding the natural
;; numbers. So the 7th triangle number would be 1 + 2 + 3 + 4 + 5 + 6
;; + 7 = 28. The first ten terms would be:

;; 1, 3, 6, 10, 15, 21, 28, 36, 45, 55, ...

;; Let us list the factors of the first seven triangle numbers:

;;      1: 1
;;      3: 1,3
;;      6: 1,2,3,6
;;     10: 1,2,5,10
;;     15: 1,3,5,15
;;     21: 1,3,7,21
;;     28: 1,2,4,7,14,28

;; We can see that the 7th triangle number, 28, is the first triangle
;; number to have over five divisors.

;; Which is the first triangle number to have over five-hundred divisors

(defun make-triangle-spigot ()
  (let ((last-num 1)
	(prev 0))
    (lambda ()
      (prog1
	  (setf prev (+ prev last-num))
	(incf last-num)))))

;; (let ((triangle (make-triangle-spigot)))
;;   (loop for ii from 1 to 10
;; 	do
;; 	(format t "~a:~a~&"
;; 		ii
;; 		(funcall triangle))))

(defun compute-triangle (nth)
  (/
   (* nth (+ nth 1))
   2))

;(find-divisors (compute-triangle 100))

;; (defun find-divisors (num)
;;   (sort 
;;    (append (list 1 num)
;; 	   (loop for ii from 2 to (ceiling (/ num 2))
;; 		 when (= 0 (mod num ii))
;; 		 collect ii))
;;    #'<))

(defun list-unique (things)
  (let ((ht (make-hash-table))
	(result (list)))
    (loop for thing in things
	  do
	  (when (not (gethash thing ht))
	    (setf (gethash thing ht) t)
	    (push thing result)))
    (reverse result)))

; (list-unique '(a b c a a b c))

(defun hash-table-keys (ht)
  (loop for k being the hash-keys of ht
	collect k))

(defun ht-find-divisors2 (num)
  (sort 
   (append (list 1 num)
	   (list-unique
	    (let ((result (make-hash-table)))
	      (loop for ii from 2 to (ceiling (sqrt num))
		    do
		    (when (= 0 (mod num ii))
		      (setf (gethash ii result) t)
		      (setf (gethash (/ num ii) result) t)))
	      (hash-table-keys result))))
   #'<))

; (find-divisors2 (compute-triangle 100))

(defun find-divisors2 (num)
  (sort 
   (list-unique
    (append (list 1 num)
	    (let ((result (list)))
	      (loop for ii from 2 to (ceiling (sqrt num))
		    do
		    (when (= 0 (mod num ii))
		      (push ii result)
		      (push (/ num ii) result)))
	      result)))
   #'<))

;; (loop for ii from 1 to 100
;;       do
;;       (assert (equalp
;; 	       (find-divisors (compute-triangle ii))
;; 	       (find-divisors2 (compute-triangle ii)))))

;(time (loop for ii from 1 to 1000 do (orig-find-divisors2 (compute-triangle ii))))
;(time (loop for ii from 1 to 1000 do (find-divisors2 (compute-triangle ii))))

(defun find-max-triangle (target-num-divisors)
  (let ((spig (make-triangle-spigot))
	(cnt 0))
    ;(loop for num = (funcall spig) then (funcall spig)
    (loop for ii = 1 then (+ ii 1)
	  for num = (compute-triangle ii) then (compute-triangle ii)
	  do
	  (let ((divisors (find-divisors2 num)))
;; 	    (when (= 0 (mod (incf cnt) 100))
;; 	      (format t "num:(~a): ~a:~a~&"
;; 		      num
;; 		      (length divisors)
;; 		      divisors))
	    (when (> (length divisors) target-num-divisors)
	      (format t "found num(~a): ~a:~a~&"
		      num
		      (length divisors)
		      divisors)
	      (return num))))))

; (time (find-max-triangle 500)) ;; 5.432 seconds
; (time (find-max-triangle 500))












;; (defvar *primes*
;;     (make-hash-table :size 10000))

;; (setf *primes*
;;       (make-hash-table :size 10000))

;; (setf (gethash 2 *primes*) t)
;; (setf (gethash 3 *primes*) t)
;; (setf (gethash 5 *primes*) t)

;; (defun dump-prime-table ()
;;   (loop for num being the hash-keys of *primes*
;; 	do
;; 	(format t "prime:~a~&" num)))

;; (defun get-cached-primes ()
;;   (loop for num being the hash-keys of *primes*
;; 	collect num))

;; ; (dump-prime-table)
;; ; (get-cached-primes)

;; (defun is-prime (num)
;;   (cond ((gethash num *primes*)
;; 	 t)
;; 	((= 1 num)
;; 	 nil)
;; 	(t
;; 	 (let ((result t))
;; 	   (loop for div from (ceiling (sqrt num)) downto 2
;; 		 do
;; 		 (when (= 0 (mod num div))
;; 		   (return (setf result nil))))
;; 	   (if result
;; 	       (setf (gethash num *primes*) t))
;; 	   result))))

;; (defun get-max-cached-prime ()
;;   (first (sort (get-cached-primes) #'>)))

;; ; (get-max-cached-prime)
;; ; (sort (get-cached-primes) #'<)

;; (defun primes-below (num)
;;   (let ((max-prime (get-max-cached-prime)))
;;     (cond ((< num max-prime)
;; 	   (remove-if #'(lambda (elt)
;; 			  (< num elt))
;; 		      (get-cached-primes)))
;; 	  (t
;; 	   (loop for ii = max-prime then (+ ii 2)
;; 		 when (< ii num)
;; 		 do
;; 		 (format t "testing:~a~&" ii)
;; 		 (is-prime ii))
;; 	   (primes-below num)))))

;; ; (primes-below 4)
;; ; (primes-below 5)

;; '(loop for ii from 1 to 1000
;;       do
;;       (format t "~a: ~a~&" ii (primes-below ii)))

;; '(loop for ii from 1 to 100
;;   do
;;   (format t "is-prime: ~a => ~a~&" ii (is-prime ii)))

;; ;; make sure we have all the primes up to 1/2 of the number